Basic Object Manipulation

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

Functions
Basic Object Manipulation
Evas » Generic Object Functions

Almost every evas object created will have some generic function used to manipulate it. More...

## Functions
EOAPI void | efl_gfx_color_set (int r, int g, int b, int a)
| Sets the general/main color of the given Evas object to the given one. More...
EOAPI void | efl_gfx_color_get (int *r, int *g, int *b, int *a)
| Retrieves the general/main color of the given Evas object. More...
void | efl::gfx::base::color_get (int *r_, int *g_, int *b_, int *a_) const
| Retrieves the general/main color of the given Evas object. More...
void | efl::gfx::base::color_set (int r_, int g_, int b_, int a_) const
| Sets the general/main color of the given Evas object to the given one. More...
void | evas_object_ref (Evas_Object *obj)
| Increments object reference count to defer its deletion. More...
void | evas_object_unref (Evas_Object *obj)
| Decrements object reference count. More...
int | evas_object_ref_get (const Evas_Object *obj)
| Get the object reference count. More...
void | evas_object_del (Evas_Object *obj)
| Marks the given Evas object for deletion (when Evas will free its memory). More...
void | evas_object_geometry_get (const Evas_Object *obj, Evas_Coord *x, Evas_Coord *y, Evas_Coord *w, Evas_Coord *h)
| Retrieves the position and (rectangular) size of the given Evas object. More...
void | evas_object_geometry_set (Evas_Object *obj, Evas_Coord x, Evas_Coord y, Evas_Coord w, Evas_Coord h)
| Set the position and (rectangular) size of the given Evas object. More...
void | evas_object_show (Evas_Object *obj)
| Makes the given Evas object visible. More...
void | evas_object_hide (Evas_Object *obj)
| Makes the given Evas object invisible. More...
void | evas_object_color_set (Evas_Object *obj, int r, int g, int b, int a)
| Sets the general/main color of the given Evas object to the given one. More...
void | evas_object_color_get (const Evas_Object *obj, int *r, int *g, int *b, int *a)
| Retrieves the general/main color of the given Evas object. More...

## Detailed Description

Almost every evas object created will have some generic function used to manipulate it.

That's because there are a number of basic actions to be done to objects that are irrespective of the object's type, things like:

- Showing/Hiding
- Setting(and getting) geometry
- Bring up or down a layer
- Color management
- Handling focus
- Clipping
- Reference counting

All of this issues are handled through the functions here grouped. Examples of these function can be seen in Evas objects basic manipulation example(which deals with the most common ones) and in Evas object stacking functions (and some event handling)(which deals with stacking functions).

## Function Documentation

EOAPI void efl_gfx_color_set | ( | int | r,
|  | int | g,
|  | int | b,
|  | int | a
| ) |  |

Sets the general/main color of the given Evas object to the given one.

See also
  evas_object_color_get() (for an example)

Note
  These color values are expected to be premultiplied by `a`.

Parameters

  [in] | r | The red component of the given color.
  [in] | g | The green component of the given color.
  [in] | b | The blue component of the given color.
  [in] | a | The alpha component of the given color.

Referenced by evas_object_color_set().

EOAPI void efl_gfx_color_get | ( | int * | r,
|  | int * | g,
|  | int * | b,
|  | int * | a
| ) |  |

Retrieves the general/main color of the given Evas object.

Retrieves the “main” color's RGB component (and alpha channel) values, which range from 0 to 255. For the alpha channel, which defines the object's transparency level, 0 means totally transparent, while 255 means opaque. These color values are premultiplied by the alpha value.

Usually you’ll use this attribute for text and rectangle objects, where the “main” color is their unique one. If set for objects which themselves have colors, like the images one, those colors get modulated by this one.

Note
  All newly created Evas rectangles get the default color values of `255 255 255 255` (opaque white).
  Use `NULL` pointers on the components you're not interested in: they'll be ignored by the function.

Example:

1 int alpha, r, g, b;
2
3 evas_object_color_get(d.clipper, &r, &g, &b, &alpha);
4 evas_color_argb_unpremul(alpha, &r, &g, &b);
5
6 alpha -= 20;
7 if (alpha < 0)
8 alpha = 255;
9
10 evas_color_argb_premul(alpha, &r, &g, &b);
11 evas_object_color_set(d.clipper, r, g, b, alpha);
12
13 fprintf(stdout, "Changing clipper's opacity: %d%%\n",
14 (int)((alpha / 255.0) * 100));
15 return;

See the full example.

Parameters

  [out] | r | The red component of the given color.
  [out] | g | The green component of the given color.
  [out] | b | The blue component of the given color.
  [out] | a | The alpha component of the given color.

Referenced by evas_object_color_get().

void efl::gfx::base::color_get | ( | int * | r_,
|  | int * | g_,
|  | int * | b_,
|  | int * | a_
| ) |  | const

Retrieves the general/main color of the given Evas object.

Retrieves the “main” color's RGB component (and alpha channel) values, which range from 0 to 255. For the alpha channel, which defines the object's transparency level, 0 means totally transparent, while 255 means opaque. These color values are premultiplied by the alpha value.

Usually you’ll use this attribute for text and rectangle objects, where the “main” color is their unique one. If set for objects which themselves have colors, like the images one, those colors get modulated by this one.

Note
  All newly created Evas rectangles get the default color values of `255 255 255 255` (opaque white).
  Use `NULL` pointers on the components you're not interested in: they'll be ignored by the function.

Example:

int alpha, r, g, b;
evas_object_color_get(d.clipper, &r, &g, &b, &alpha);
evas_color_argb_unpremul(alpha, &r, &g, &b);
alpha -= 20;
if (alpha < 0)
alpha = 255;
evas_color_argb_premul(alpha, &r, &g, &b);
evas_object_color_set(d.clipper, r, g, b, alpha);
fprintf(stdout, "Changing clipper's opacity: %d%%\n",
(int)((alpha / 255.0) * 100));
return;

See the full example.

Parameters

  r | The red component of the given color.
  g | The green component of the given color.
  b | The blue component of the given color.
  a | The alpha component of the given color.

void efl::gfx::base::color_set | ( | int | r_,
|  | int | g_,
|  | int | b_,
|  | int | a_
| ) |  | const

Sets the general/main color of the given Evas object to the given one.

See also
  evas_object_color_get() (for an example)

Note
  These color values are expected to be premultiplied by `a`.

Parameters

  r | The red component of the given color.
  g | The green component of the given color.
  b | The blue component of the given color.
  a | The alpha component of the given color.

void evas_object_ref | ( | Evas_Object * | obj | ) |

Increments object reference count to defer its deletion.

Parameters

  obj | The given Evas object to reference

This increments the reference count of an object, which if greater than 0 will defer deletion by evas_object_del() until all references are released back (counter back to 0). References cannot go below 0 and unreferencing past that will result in the reference count being limited to 0. References are limited to `2^32 - 1` for an object. Referencing it more than this will result in it being limited to this value.

See also
  evas_object_unref()
  evas_object_del()

Note
  This is a very simple reference counting mechanism! For instance, Evas is not ready to check for pending references on a canvas deletion, or things like that. This is useful on scenarios where, inside a code block, callbacks exist which would possibly delete an object we are operating on afterwards. Then, one would evas_object_ref() it on the beginning of the block and evas_object_unref() it on the end. It would then be deleted at this point, if it should be.

Example:

1 evas_object_ref(obj);
2
3 // action here...
4 evas_object_smart_callback_call(obj, SIG_SELECTED, NULL);
5 // more action here...
6 evas_object_unref(obj);

Since
  1.1

void evas_object_unref | ( | Evas_Object * | obj | ) |

Decrements object reference count.

Parameters

  obj | The given Evas object to unreference

This decrements the reference count of an object. If the object has had evas_object_del() called on it while references were more than 0, it will be deleted at the time this function is called and puts the counter back to 0. See evas_object_ref() for more information.

See also
  evas_object_ref() (for an example)
  evas_object_del()

Since
  1.1

References evas_object_del().

int evas_object_ref_get | ( | const Evas_Object * | obj | ) |

Get the object reference count.

Parameters

  obj | The given Evas object to query

This gets the reference count for an object (normally 0 until it is referenced). Values of 1 or greater mean that someone is holding a reference to this object that needs to be unreffed before it can be deleted.

See also
  evas_object_ref()
  evas_object_unref()
  evas_object_del()

Since
  1.2

void evas_object_del | ( | Evas_Object * | obj | ) |

Marks the given Evas object for deletion (when Evas will free its memory).

Parameters

  obj | The given Evas object.

This call will mark `obj` for deletion, which will take place whenever it has no more references to it (see evas_object_ref() and evas_object_unref()).

At actual deletion time, which may or may not be just after this call, EVAS_CALLBACK_DEL and EVAS_CALLBACK_FREE callbacks will be called. If the object currently had the focus, its EVAS_CALLBACK_FOCUS_OUT callback will also be called.

See also
  evas_object_ref()
  evas_object_unref()

References EINA_TRUE.

Referenced by ecore_evas_ews_background_set(), edje_edit_part_source_set(), edje_perspective_free(), ethumb_free(), and evas_object_unref().

void evas_object_geometry_get | ( | const Evas_Object * | obj,
|  | Evas_Coord * | x,
|  | Evas_Coord * | y,
|  | Evas_Coord * | w,
|  | Evas_Coord * | h
| ) |  |

Retrieves the position and (rectangular) size of the given Evas object.

Parameters

  obj | The given Evas object.
  x | Pointer to an integer in which to store the X coordinate of the object.
  y | Pointer to an integer in which to store the Y coordinate of the object.
  w | Pointer to an integer in which to store the width of the object.
  h | Pointer to an integer in which to store the height of the object.

The position, naturally, will be relative to the top left corner of the canvas' viewport.

Note
  Use `NULL` pointers on the geometry components you're not interested in: they'll be ignored by the function.

Example:

1 int w, h, cw, ch;
2
3 evas_object_geometry_get(d.img, NULL, NULL, &w, &h);
4 ecore_evas_geometry_get(d.ee, NULL, NULL, &cw, &ch);
5
6 if (w < cw)
7 evas_object_resize(d.img, cw, ch);
8 else
9 evas_object_resize(d.img, cw / 2, ch / 2);
10
11 return EINA_TRUE; /* re-issue the timer */

See the full example.

Referenced by emotion_object_border_set(), emotion_object_keep_aspect_set(), and evas_textblock_cursor_range_simple_geometry_get().

void evas_object_geometry_set | ( | Evas_Object * | obj,
|  | Evas_Coord | x,
|  | Evas_Coord | y,
|  | Evas_Coord | w,
|  | Evas_Coord | h
| ) |  |

Set the position and (rectangular) size of the given Evas object.

Parameters

  obj | The given Evas object.
  x | X position to move the object to, in canvas units.
  y | Y position to move the object to, in canvas units.
  w | The new width of the Evas object.
  h | The new height of the Evas object.

The position, naturally, will be relative to the top left corner of the canvas' viewport.

If the object get moved, the object's EVAS_CALLBACK_MOVE callback will be called.

If the object get resized, the object's EVAS_CALLBACK_RESIZE callback will be called.

See also
  evas_object_move()
  evas_object_resize()
  evas_object_geometry_get

Since
  1.8

void evas_object_show | ( | Evas_Object * | obj | ) |

Makes the given Evas object visible.

Parameters

  obj | The given Evas object.

Besides becoming visible, the object's EVAS_CALLBACK_SHOW callback will be called.

See also
  evas_object_hide() for more on object visibility.
  evas_object_visible_get()

References EINA_TRUE.

Referenced by ecore_evas_ews_background_set(), and emotion_object_bg_color_set().

void evas_object_hide | ( | Evas_Object * | obj | ) |

Makes the given Evas object invisible.

Parameters

  obj | The given Evas object.

Hidden objects, besides not being shown at all in your canvas, won't be checked for changes on the canvas rendering process. Furthermore, they will not catch input events. Thus, they are much ligher (in processing needs) than an object that is invisible due to indirect causes, such as being clipped or out of the canvas' viewport.

Besides becoming hidden, `obj` object's EVAS_CALLBACK_SHOW callback will be called.

Note
  All objects are created in the hidden state! If you want them shown, use evas_object_show() after their creation.

See also
  evas_object_show()
  evas_object_visible_get()

Example:

1 if (evas_object_visible_get(d.clipper))
2 {
3 evas_object_hide(d.clipper);
4 fprintf(stdout, "hidden\n");
5 }
6 else
7 {
8 evas_object_show(d.clipper);
9 fprintf(stdout, "visible\n");
10 }
11 return;

See the full example.

References EINA_FALSE.

Referenced by ecore_evas_cursor_unset(), edje_edit_part_del(), and emotion_object_bg_color_set().

void evas_object_color_set | ( | Evas_Object * | obj,
|  | int | r,
|  | int | g,
|  | int | b,
|  | int | a
| ) |  |

Sets the general/main color of the given Evas object to the given one.

See also
  evas_object_color_get() (for an example)

Note
  These color values are expected to be premultiplied by `a`.

Parameters

  [in] | r | The red component of the given color.
  [in] | g | The green component of the given color.
  [in] | b | The blue component of the given color.
  [in] | a | The alpha component of the given color.

References efl_gfx_color_set().

Referenced by ecore_evas_ews_background_set(), and emotion_object_bg_color_set().

void evas_object_color_get | ( | const Evas_Object * | obj,
|  | int * | r,
|  | int * | g,
|  | int * | b,
|  | int * | a
| ) |  |

Retrieves the general/main color of the given Evas object.

Retrieves the “main” color's RGB component (and alpha channel) values, which range from 0 to 255. For the alpha channel, which defines the object's transparency level, 0 means totally transparent, while 255 means opaque. These color values are premultiplied by the alpha value.

Usually you’ll use this attribute for text and rectangle objects, where the “main” color is their unique one. If set for objects which themselves have colors, like the images one, those colors get modulated by this one.

Note
  All newly created Evas rectangles get the default color values of `255 255 255 255` (opaque white).
  Use `NULL` pointers on the components you're not interested in: they'll be ignored by the function.

Example:

1 int alpha, r, g, b;
2
3 evas_object_color_get(d.clipper, &r, &g, &b, &alpha);
4 evas_color_argb_unpremul(alpha, &r, &g, &b);
5
6 alpha -= 20;
7 if (alpha < 0)
8 alpha = 255;
9
10 evas_color_argb_premul(alpha, &r, &g, &b);
11 evas_object_color_set(d.clipper, r, g, b, alpha);
12
13 fprintf(stdout, "Changing clipper's opacity: %d%%\n",
14 (int)((alpha / 255.0) * 100));
15 return;

See the full example.

Parameters

  [out] | r | The red component of the given color.
  [out] | g | The green component of the given color.
  [out] | b | The blue component of the given color.
  [out] | a | The alpha component of the given color.

References efl_gfx_color_get().

Referenced by emotion_object_bg_color_get().